#ifndef _HTTP_H_
#define _HTTP_H_
#include <stdlib.h>
#include <stdio.h>
#include <openssl/ssl.h>
#include <openssl/err.h>

#define MAX_HEADER_SIZE 1400
#define HTTP_DEBUG 	0

struct request_rec 
{
	int     sd;                     /* socket id */
	char	szIn_buf[MAX_HEADER_SIZE];	/* buffer for headers */
	char  *in_buf;                /* pointer to incoming header buffer */
	int     in_buf_used;            /* how many bytes now is used */
	int     in_header_lens;         /* added to indicate the ending of header */
	int useSSL;
	SSL* ssl;
};

int getHeader(struct request_rec *rec, int timeout);
int ht_getline(struct request_rec *rec, char *linebuf, int buflen); 
int read_chunkdata(char *orgdata, int bytes);
SSL_CTX *InitSSLClient();
void CloseSSLClient(SSL *ssl);
int recvdatapayload(struct request_rec *rec, char **data);
int senddata(struct request_rec *rec, char *buf, int buflen, int flag);

#endif

